package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.QualificationAttributeDefinition;
import de.humance.eco.profile.model.QualificationAttributeDefinitionModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the QualificationAttributeDefinition service. Represents a row in the &quot;Profile_QualificationAttributeDefinition&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.QualificationAttributeDefinitionModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link QualificationAttributeDefinitionImpl}.
 * </p>
 *
 * @author Humance
 * @see QualificationAttributeDefinitionImpl
 * @see de.humance.eco.profile.model.QualificationAttributeDefinition
 * @see de.humance.eco.profile.model.QualificationAttributeDefinitionModel
 * @generated
 */
public class QualificationAttributeDefinitionModelImpl extends BaseModelImpl<QualificationAttributeDefinition>
    implements QualificationAttributeDefinitionModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a qualification attribute definition model instance should use the {@link de.humance.eco.profile.model.QualificationAttributeDefinition} interface instead.
     */
    public static final String TABLE_NAME = "Profile_QualificationAttributeDefinition";
    public static final Object[][] TABLE_COLUMNS = {
            { "qualificationAttributeDefinitionId", Types.BIGINT },
            { "creatorId", Types.BIGINT },
            { "creatorName", Types.VARCHAR },
            { "createDate", Types.TIMESTAMP },
            { "modifierId", Types.BIGINT },
            { "modifierName", Types.VARCHAR },
            { "modifiedDate", Types.TIMESTAMP },
            { "qualificationTypeId", Types.BIGINT },
            { "type_", Types.VARCHAR },
            { "title", Types.VARCHAR },
            { "minRangeValue", Types.DOUBLE },
            { "maxRangeValue", Types.DOUBLE },
            { "unit", Types.VARCHAR },
            { "sequenceNumber", Types.BIGINT }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_QualificationAttributeDefinition (qualificationAttributeDefinitionId LONG not null primary key,creatorId LONG,creatorName VARCHAR(75) null,createDate DATE null,modifierId LONG,modifierName VARCHAR(75) null,modifiedDate DATE null,qualificationTypeId LONG,type_ VARCHAR(75) null,title VARCHAR(500) null,minRangeValue DOUBLE,maxRangeValue DOUBLE,unit VARCHAR(255) null,sequenceNumber LONG)";
    public static final String TABLE_SQL_DROP = "drop table Profile_QualificationAttributeDefinition";
    public static final String ORDER_BY_JPQL = " ORDER BY qualificationAttributeDefinition.qualificationTypeId ASC, qualificationAttributeDefinition.sequenceNumber ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_QualificationAttributeDefinition.qualificationTypeId ASC, Profile_QualificationAttributeDefinition.sequenceNumber ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.QualificationAttributeDefinition"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.QualificationAttributeDefinition"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.QualificationAttributeDefinition"),
            true);
    public static long QUALIFICATIONTYPEID_COLUMN_BITMASK = 1L;
    public static long TITLE_COLUMN_BITMASK = 2L;
    public static long SEQUENCENUMBER_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.QualificationAttributeDefinition"));
    private static ClassLoader _classLoader = QualificationAttributeDefinition.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            QualificationAttributeDefinition.class
        };
    private long _qualificationAttributeDefinitionId;
    private long _creatorId;
    private String _creatorName;
    private Date _createDate;
    private long _modifierId;
    private String _modifierName;
    private Date _modifiedDate;
    private long _qualificationTypeId;
    private long _originalQualificationTypeId;
    private boolean _setOriginalQualificationTypeId;
    private String _type;
    private String _title;
    private String _originalTitle;
    private double _minRangeValue;
    private double _maxRangeValue;
    private String _unit;
    private long _sequenceNumber;
    private long _columnBitmask;
    private QualificationAttributeDefinition _escapedModel;

    public QualificationAttributeDefinitionModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _qualificationAttributeDefinitionId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setQualificationAttributeDefinitionId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _qualificationAttributeDefinitionId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return QualificationAttributeDefinition.class;
    }

    @Override
    public String getModelClassName() {
        return QualificationAttributeDefinition.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("qualificationAttributeDefinitionId",
            getQualificationAttributeDefinitionId());
        attributes.put("creatorId", getCreatorId());
        attributes.put("creatorName", getCreatorName());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifierId", getModifierId());
        attributes.put("modifierName", getModifierName());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("qualificationTypeId", getQualificationTypeId());
        attributes.put("type", getType());
        attributes.put("title", getTitle());
        attributes.put("minRangeValue", getMinRangeValue());
        attributes.put("maxRangeValue", getMaxRangeValue());
        attributes.put("unit", getUnit());
        attributes.put("sequenceNumber", getSequenceNumber());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long qualificationAttributeDefinitionId = (Long) attributes.get(
                "qualificationAttributeDefinitionId");

        if (qualificationAttributeDefinitionId != null) {
            setQualificationAttributeDefinitionId(qualificationAttributeDefinitionId);
        }

        Long creatorId = (Long) attributes.get("creatorId");

        if (creatorId != null) {
            setCreatorId(creatorId);
        }

        String creatorName = (String) attributes.get("creatorName");

        if (creatorName != null) {
            setCreatorName(creatorName);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Long modifierId = (Long) attributes.get("modifierId");

        if (modifierId != null) {
            setModifierId(modifierId);
        }

        String modifierName = (String) attributes.get("modifierName");

        if (modifierName != null) {
            setModifierName(modifierName);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        Long qualificationTypeId = (Long) attributes.get("qualificationTypeId");

        if (qualificationTypeId != null) {
            setQualificationTypeId(qualificationTypeId);
        }

        String type = (String) attributes.get("type");

        if (type != null) {
            setType(type);
        }

        String title = (String) attributes.get("title");

        if (title != null) {
            setTitle(title);
        }

        Double minRangeValue = (Double) attributes.get("minRangeValue");

        if (minRangeValue != null) {
            setMinRangeValue(minRangeValue);
        }

        Double maxRangeValue = (Double) attributes.get("maxRangeValue");

        if (maxRangeValue != null) {
            setMaxRangeValue(maxRangeValue);
        }

        String unit = (String) attributes.get("unit");

        if (unit != null) {
            setUnit(unit);
        }

        Long sequenceNumber = (Long) attributes.get("sequenceNumber");

        if (sequenceNumber != null) {
            setSequenceNumber(sequenceNumber);
        }
    }

    @Override
    public long getQualificationAttributeDefinitionId() {
        return _qualificationAttributeDefinitionId;
    }

    @Override
    public void setQualificationAttributeDefinitionId(
        long qualificationAttributeDefinitionId) {
        _qualificationAttributeDefinitionId = qualificationAttributeDefinitionId;
    }

    @Override
    public long getCreatorId() {
        return _creatorId;
    }

    @Override
    public void setCreatorId(long creatorId) {
        _creatorId = creatorId;
    }

    @Override
    public String getCreatorName() {
        if (_creatorName == null) {
            return StringPool.BLANK;
        } else {
            return _creatorName;
        }
    }

    @Override
    public void setCreatorName(String creatorName) {
        _creatorName = creatorName;
    }

    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    @Override
    public long getModifierId() {
        return _modifierId;
    }

    @Override
    public void setModifierId(long modifierId) {
        _modifierId = modifierId;
    }

    @Override
    public String getModifierName() {
        if (_modifierName == null) {
            return StringPool.BLANK;
        } else {
            return _modifierName;
        }
    }

    @Override
    public void setModifierName(String modifierName) {
        _modifierName = modifierName;
    }

    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    @Override
    public long getQualificationTypeId() {
        return _qualificationTypeId;
    }

    @Override
    public void setQualificationTypeId(long qualificationTypeId) {
        _columnBitmask = -1L;

        if (!_setOriginalQualificationTypeId) {
            _setOriginalQualificationTypeId = true;

            _originalQualificationTypeId = _qualificationTypeId;
        }

        _qualificationTypeId = qualificationTypeId;
    }

    public long getOriginalQualificationTypeId() {
        return _originalQualificationTypeId;
    }

    @Override
    public String getType() {
        if (_type == null) {
            return StringPool.BLANK;
        } else {
            return _type;
        }
    }

    @Override
    public void setType(String type) {
        _type = type;
    }

    @Override
    public String getTitle() {
        if (_title == null) {
            return StringPool.BLANK;
        } else {
            return _title;
        }
    }

    @Override
    public void setTitle(String title) {
        _columnBitmask |= TITLE_COLUMN_BITMASK;

        if (_originalTitle == null) {
            _originalTitle = _title;
        }

        _title = title;
    }

    public String getOriginalTitle() {
        return GetterUtil.getString(_originalTitle);
    }

    @Override
    public double getMinRangeValue() {
        return _minRangeValue;
    }

    @Override
    public void setMinRangeValue(double minRangeValue) {
        _minRangeValue = minRangeValue;
    }

    @Override
    public double getMaxRangeValue() {
        return _maxRangeValue;
    }

    @Override
    public void setMaxRangeValue(double maxRangeValue) {
        _maxRangeValue = maxRangeValue;
    }

    @Override
    public String getUnit() {
        if (_unit == null) {
            return StringPool.BLANK;
        } else {
            return _unit;
        }
    }

    @Override
    public void setUnit(String unit) {
        _unit = unit;
    }

    @Override
    public long getSequenceNumber() {
        return _sequenceNumber;
    }

    @Override
    public void setSequenceNumber(long sequenceNumber) {
        _columnBitmask = -1L;

        _sequenceNumber = sequenceNumber;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            QualificationAttributeDefinition.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public QualificationAttributeDefinition toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (QualificationAttributeDefinition) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        QualificationAttributeDefinitionImpl qualificationAttributeDefinitionImpl =
            new QualificationAttributeDefinitionImpl();

        qualificationAttributeDefinitionImpl.setQualificationAttributeDefinitionId(getQualificationAttributeDefinitionId());
        qualificationAttributeDefinitionImpl.setCreatorId(getCreatorId());
        qualificationAttributeDefinitionImpl.setCreatorName(getCreatorName());
        qualificationAttributeDefinitionImpl.setCreateDate(getCreateDate());
        qualificationAttributeDefinitionImpl.setModifierId(getModifierId());
        qualificationAttributeDefinitionImpl.setModifierName(getModifierName());
        qualificationAttributeDefinitionImpl.setModifiedDate(getModifiedDate());
        qualificationAttributeDefinitionImpl.setQualificationTypeId(getQualificationTypeId());
        qualificationAttributeDefinitionImpl.setType(getType());
        qualificationAttributeDefinitionImpl.setTitle(getTitle());
        qualificationAttributeDefinitionImpl.setMinRangeValue(getMinRangeValue());
        qualificationAttributeDefinitionImpl.setMaxRangeValue(getMaxRangeValue());
        qualificationAttributeDefinitionImpl.setUnit(getUnit());
        qualificationAttributeDefinitionImpl.setSequenceNumber(getSequenceNumber());

        qualificationAttributeDefinitionImpl.resetOriginalValues();

        return qualificationAttributeDefinitionImpl;
    }

    @Override
    public int compareTo(
        QualificationAttributeDefinition qualificationAttributeDefinition) {
        int value = 0;

        if (getQualificationTypeId() < qualificationAttributeDefinition.getQualificationTypeId()) {
            value = -1;
        } else if (getQualificationTypeId() > qualificationAttributeDefinition.getQualificationTypeId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        if (getSequenceNumber() < qualificationAttributeDefinition.getSequenceNumber()) {
            value = -1;
        } else if (getSequenceNumber() > qualificationAttributeDefinition.getSequenceNumber()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof QualificationAttributeDefinition)) {
            return false;
        }

        QualificationAttributeDefinition qualificationAttributeDefinition = (QualificationAttributeDefinition) obj;

        long primaryKey = qualificationAttributeDefinition.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        QualificationAttributeDefinitionModelImpl qualificationAttributeDefinitionModelImpl =
            this;

        qualificationAttributeDefinitionModelImpl._originalQualificationTypeId = qualificationAttributeDefinitionModelImpl._qualificationTypeId;

        qualificationAttributeDefinitionModelImpl._setOriginalQualificationTypeId = false;

        qualificationAttributeDefinitionModelImpl._originalTitle = qualificationAttributeDefinitionModelImpl._title;

        qualificationAttributeDefinitionModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<QualificationAttributeDefinition> toCacheModel() {
        QualificationAttributeDefinitionCacheModel qualificationAttributeDefinitionCacheModel =
            new QualificationAttributeDefinitionCacheModel();

        qualificationAttributeDefinitionCacheModel.qualificationAttributeDefinitionId = getQualificationAttributeDefinitionId();

        qualificationAttributeDefinitionCacheModel.creatorId = getCreatorId();

        qualificationAttributeDefinitionCacheModel.creatorName = getCreatorName();

        String creatorName = qualificationAttributeDefinitionCacheModel.creatorName;

        if ((creatorName != null) && (creatorName.length() == 0)) {
            qualificationAttributeDefinitionCacheModel.creatorName = null;
        }

        Date createDate = getCreateDate();

        if (createDate != null) {
            qualificationAttributeDefinitionCacheModel.createDate = createDate.getTime();
        } else {
            qualificationAttributeDefinitionCacheModel.createDate = Long.MIN_VALUE;
        }

        qualificationAttributeDefinitionCacheModel.modifierId = getModifierId();

        qualificationAttributeDefinitionCacheModel.modifierName = getModifierName();

        String modifierName = qualificationAttributeDefinitionCacheModel.modifierName;

        if ((modifierName != null) && (modifierName.length() == 0)) {
            qualificationAttributeDefinitionCacheModel.modifierName = null;
        }

        Date modifiedDate = getModifiedDate();

        if (modifiedDate != null) {
            qualificationAttributeDefinitionCacheModel.modifiedDate = modifiedDate.getTime();
        } else {
            qualificationAttributeDefinitionCacheModel.modifiedDate = Long.MIN_VALUE;
        }

        qualificationAttributeDefinitionCacheModel.qualificationTypeId = getQualificationTypeId();

        qualificationAttributeDefinitionCacheModel.type = getType();

        String type = qualificationAttributeDefinitionCacheModel.type;

        if ((type != null) && (type.length() == 0)) {
            qualificationAttributeDefinitionCacheModel.type = null;
        }

        qualificationAttributeDefinitionCacheModel.title = getTitle();

        String title = qualificationAttributeDefinitionCacheModel.title;

        if ((title != null) && (title.length() == 0)) {
            qualificationAttributeDefinitionCacheModel.title = null;
        }

        qualificationAttributeDefinitionCacheModel.minRangeValue = getMinRangeValue();

        qualificationAttributeDefinitionCacheModel.maxRangeValue = getMaxRangeValue();

        qualificationAttributeDefinitionCacheModel.unit = getUnit();

        String unit = qualificationAttributeDefinitionCacheModel.unit;

        if ((unit != null) && (unit.length() == 0)) {
            qualificationAttributeDefinitionCacheModel.unit = null;
        }

        qualificationAttributeDefinitionCacheModel.sequenceNumber = getSequenceNumber();

        return qualificationAttributeDefinitionCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(29);

        sb.append("{qualificationAttributeDefinitionId=");
        sb.append(getQualificationAttributeDefinitionId());
        sb.append(", creatorId=");
        sb.append(getCreatorId());
        sb.append(", creatorName=");
        sb.append(getCreatorName());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifierId=");
        sb.append(getModifierId());
        sb.append(", modifierName=");
        sb.append(getModifierName());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", qualificationTypeId=");
        sb.append(getQualificationTypeId());
        sb.append(", type=");
        sb.append(getType());
        sb.append(", title=");
        sb.append(getTitle());
        sb.append(", minRangeValue=");
        sb.append(getMinRangeValue());
        sb.append(", maxRangeValue=");
        sb.append(getMaxRangeValue());
        sb.append(", unit=");
        sb.append(getUnit());
        sb.append(", sequenceNumber=");
        sb.append(getSequenceNumber());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(46);

        sb.append("<model><model-name>");
        sb.append(
            "de.humance.eco.profile.model.QualificationAttributeDefinition");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>qualificationAttributeDefinitionId</column-name><column-value><![CDATA[");
        sb.append(getQualificationAttributeDefinitionId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorId</column-name><column-value><![CDATA[");
        sb.append(getCreatorId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorName</column-name><column-value><![CDATA[");
        sb.append(getCreatorName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierId</column-name><column-value><![CDATA[");
        sb.append(getModifierId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierName</column-name><column-value><![CDATA[");
        sb.append(getModifierName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>qualificationTypeId</column-name><column-value><![CDATA[");
        sb.append(getQualificationTypeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>type</column-name><column-value><![CDATA[");
        sb.append(getType());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>title</column-name><column-value><![CDATA[");
        sb.append(getTitle());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>minRangeValue</column-name><column-value><![CDATA[");
        sb.append(getMinRangeValue());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>maxRangeValue</column-name><column-value><![CDATA[");
        sb.append(getMaxRangeValue());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>unit</column-name><column-value><![CDATA[");
        sb.append(getUnit());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>sequenceNumber</column-name><column-value><![CDATA[");
        sb.append(getSequenceNumber());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
